(provide 'english)
(provide 'unix)

(defmacro in-package (package-name)
  `',package-name)

(defmacro defun (name lambda-list . forms)
  `(define ,(cons name lambda-list) ,@forms))

(define (proclaim form) #f)

(define (function a . args) a)

(defmacro:load (in-vicinity (program-vicinity) "defmacro.lsp"))
(defmacro:load (in-vicinity (program-vicinity) "defs1.lsp"))
(defmacro:load (in-vicinity (program-vicinity) "defs2.lsp"))
(defmacro:load (in-vicinity (program-vicinity) "defstruc.lsp"))
(defmacro:load (in-vicinity (program-vicinity) "macros1.lsp"))
(defmacro:load (in-vicinity (program-vicinity) "macros2.lsp"))
(defmacro:load (in-vicinity (program-vicinity) "macros3.lsp"))
(defmacro:load (in-vicinity (program-vicinity) "places.lsp"))

(require 'ppfile)
(require 'defmacroexpand)

(define (delispfilify file)
  (define stl (string-length file))
  (define (remove-suffix suf)
    (let ((sfl (string-length suf)))
      (cond ((< stl sfl) file)
	    ((string-ci=? (substring file (- stl sfl) stl) ".cl")
	     (substring file 0 (- stl sfl)))
	    (else #f))))
  (or (remove-suffix ".l")
      (remove-suffix ".cl")
      (remove-suffix ".lsp")
      (remove-suffix ".lisp")))

(define (lisp->scheme file . args)
  (define ofile (and (pair? args) (car args)))
  (set! ofile (or ofile (string-append (delispfilify file) ".scm")))
  (pprint-filter-file file defmacro:expand* ofile))
